//+------------------------------------------------------------------+
//|                                                       3_sma.mq4 |
//|                                Copyright  2009, Igor Chemodanov |
//|                                                     icas@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Igor Chemodanov"
#property link      "icas@mail.ru"

#property indicator_chart_window    // .    
#property indicator_buffers 4       //  
#property indicator_color1 DarkOrange
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Violet
#property indicator_color4 Orange

double B0[], B1[], B2[], B3[];
extern int  MAPeriod1 = 5;
extern int  MAPeriod2 = 21;
extern int  MAPeriod3 = 54;
extern int  MAPeriod4 = 87;



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
IndicatorDigits (Digits+2);

SetIndexBuffer(0,B0);         //   
SetIndexStyle (0,DRAW_LINE,STYLE_SOLID,1);
string ind="EMA"+DoubleToStr(MAPeriod1, 0);
SetIndexLabel(0, ind);

SetIndexBuffer(1,B1);         //   
SetIndexStyle (1,DRAW_LINE,STYLE_SOLID,1);//  
ind="EMA"+DoubleToStr(MAPeriod2, 0);
SetIndexLabel(1, ind);

SetIndexBuffer(2,B2);         //   
SetIndexStyle (2,DRAW_LINE,0,1);//  
ind="EMA"+DoubleToStr(MAPeriod3, 0);
SetIndexLabel(2, ind);

SetIndexBuffer(3,B3);         //   
SetIndexStyle (3,DRAW_LINE,0,1);//  
ind="EMA"+DoubleToStr(MAPeriod4, 0);
SetIndexLabel(3, ind);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----

   if(Bars<=MAPeriod4) return(0);
   int ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   
//----  
   while(pos>=0)
     {
      B0[pos] = NormalizeDouble(iMA (NULL, 0, MAPeriod1, 0, MODE_EMA, PRICE_CLOSE, pos), Digits+2);
      B1[pos] = NormalizeDouble(iMA (NULL, 0, MAPeriod2, 0, MODE_EMA, PRICE_CLOSE, pos), Digits+2);
      B2[pos] = NormalizeDouble(iMA (NULL, 0, MAPeriod3, 0, MODE_EMA, PRICE_CLOSE, pos), Digits+2);
      B3[pos] = NormalizeDouble(iMA (NULL, 0, MAPeriod4, 0, MODE_EMA, PRICE_CLOSE, pos), Digits+2);
 	   pos--;
     }
//----

//----

   return(0);
  }
//+------------------------------------------------------------------+